Index: /XIOS/dev/dev_olga/src/transformation/scalar_algorithm_extract_axis.hpp
===================================================================
--- /XIOS/dev/dev_olga/src/transformation/scalar_algorithm_extract_axis.hpp	(revision 1157)
+++ /XIOS/dev/dev_olga/src/transformation/scalar_algorithm_extract_axis.hpp	(revision 1158)
@@ -32,6 +32,6 @@
                      const double* dataInput,
                      CArray<double,1>& dataOut,
-                     std::vector<bool>& flagInitial,
-                     const double& defaultValue);
+                     std::vector<bool>& flagInitial,                     
+                     bool ignoreMissingValue);
 
   virtual ~CScalarAlgorithmExtractAxis();
Index: /XIOS/dev/dev_olga/src/transformation/scalar_algorithm_reduce_axis.cpp
===================================================================
--- /XIOS/dev/dev_olga/src/transformation/scalar_algorithm_reduce_axis.cpp	(revision 1157)
+++ /XIOS/dev/dev_olga/src/transformation/scalar_algorithm_reduce_axis.cpp	(revision 1158)
@@ -88,7 +88,7 @@
                                          CArray<double,1>& dataOut,
                                          std::vector<bool>& flagInitial,
-                                         const double& defaultValue)
+				       bool ignoreMissingValue)
 {
-  reduction_->apply(localIndex, dataInput, dataOut, flagInitial);
+  reduction_->apply(localIndex, dataInput, dataOut, flagInitial, ignoreMissingValue);
 }
 
Index: /XIOS/dev/dev_olga/src/transformation/scalar_algorithm_reduce_axis.hpp
===================================================================
--- /XIOS/dev/dev_olga/src/transformation/scalar_algorithm_reduce_axis.hpp	(revision 1157)
+++ /XIOS/dev/dev_olga/src/transformation/scalar_algorithm_reduce_axis.hpp	(revision 1158)
@@ -33,5 +33,5 @@
                      CArray<double,1>& dataOut,
                      std::vector<bool>& flagInitial,
-                     const double& defaultValue);
+                     bool ignoreMissingValue);
 
   virtual void updateData(CArray<double,1>& dataOut);
Index: /XIOS/dev/dev_olga/src/transformation/scalar_algorithm_reduce_domain.cpp
===================================================================
--- /XIOS/dev/dev_olga/src/transformation/scalar_algorithm_reduce_domain.cpp	(revision 1157)
+++ /XIOS/dev/dev_olga/src/transformation/scalar_algorithm_reduce_domain.cpp	(revision 1158)
@@ -81,8 +81,8 @@
                                          const double* dataInput,
                                          CArray<double,1>& dataOut,
-                                         std::vector<bool>& flagInitial,
-                                         const double& defaultValue)
+                                         std::vector<bool>& flagInitial,                     
+                                         bool ignoreMissingValue)
 {
-  reduction_->apply(localIndex, dataInput, dataOut, flagInitial);
+  reduction_->apply(localIndex, dataInput, dataOut, flagInitial, ignoreMissingValue);
 }
 
Index: /XIOS/dev/dev_olga/src/transformation/scalar_algorithm_reduce_domain.hpp
===================================================================
--- /XIOS/dev/dev_olga/src/transformation/scalar_algorithm_reduce_domain.hpp	(revision 1157)
+++ /XIOS/dev/dev_olga/src/transformation/scalar_algorithm_reduce_domain.hpp	(revision 1158)
@@ -32,6 +32,6 @@
                      const double* dataInput,
                      CArray<double,1>& dataOut,
-                     std::vector<bool>& flagInitial,
-                     const double& defaultValue);
+                     std::vector<bool>& flagInitial,                     
+                     bool ignoreMissingValue);
 
   virtual void updateData(CArray<double,1>& dataOut);
Index: /XIOS/dev/dev_olga/src/type/enum.hpp
===================================================================
--- /XIOS/dev/dev_olga/src/type/enum.hpp	(revision 1157)
+++ /XIOS/dev/dev_olga/src/type/enum.hpp	(revision 1158)
@@ -100,5 +100,5 @@
     __INLINE__ const CEnum_ref& operator = (const CEnum_ref& val) const;
     __INLINE__ operator T_enum&() const;
-    bool operator == (const CEnum_ref &other) {return this->get()==other.get() ;}
+    
 
     inline virtual CBaseType* clone(void) const   { return _clone(); }
@@ -134,4 +134,13 @@
   } ;
   
+  template <typename T> bool operator== (const CEnum<T>& lhs, const typename T::t_enum& rhs);
+  template <typename T> bool operator== (const typename T::t_enum& lhs, const CEnum<T>& rhs);
+  template <typename T> bool operator== (const CEnum<T>& lhs, const CEnum<T>& rhs);  
+  template <typename T> bool operator== (const CEnum_ref<T>& lhs, const CEnum_ref<T>& rhs);
+  template <typename T> bool operator== (const CEnum_ref<T>& lhs, const typename T::t_enum& rhs);
+  template <typename T> bool operator== (const typename T::t_enum& lhs, const CEnum_ref<T>& rhs);
+  template <typename T> bool operator== (const CEnum<T>& lhs, const CEnum_ref<T>& rhs) {return (lhs.get() == rhs.get());}
+  template <typename T> bool operator== (const CEnum_ref<T>& lhs, const CEnum<T>& rhs) {return (rhs == lhs); }
+
   template <typename T> __INLINE__ CBufferOut& operator<<(CBufferOut& buffer, const CEnum<T>& type) ;
   template <typename T> __INLINE__ CBufferOut& operator<<(CBufferOut& buffer, const typename T::t_enum & type) ;  
Index: /XIOS/dev/dev_olga/src/type/enum_impl.hpp
===================================================================
--- /XIOS/dev/dev_olga/src/type/enum_impl.hpp	(revision 1157)
+++ /XIOS/dev/dev_olga/src/type/enum_impl.hpp	(revision 1158)
@@ -249,6 +249,27 @@
                      << "Enum is not initialized.");
   }  
-
-  
+  
+  template <typename T> 
+  bool operator== (const CEnum<T>& lhs, const typename T::t_enum& rhs)
+  {
+     if (lhs.isEmpty()) return false;
+     return (lhs.get() == rhs);
+  }
+
+  template <typename T> 
+  bool operator== (const typename T::t_enum& lhs, const CEnum<T>& rhs)
+  {
+    return rhs == lhs;
+  }
+
+  template <typename T> 
+  bool operator== (const CEnum<T>& lhs, const CEnum<T>& rhs)
+  {
+    if ((lhs.isEmpty() && !rhs.isEmpty()) || (!lhs.isEmpty() && rhs.isEmpty())) return false;
+    if (lhs.isEmpty() && rhs.isEmpty()) return true;
+    return (lhs.get() == rhs.get());
+  }
+
+
   template <typename T>
   CBufferOut& operator<<(CBufferOut& buffer, const CEnum<T>& type)
Index: /XIOS/dev/dev_olga/src/type/enum_ref_impl.hpp
===================================================================
--- /XIOS/dev/dev_olga/src/type/enum_ref_impl.hpp	(revision 1157)
+++ /XIOS/dev/dev_olga/src/type/enum_ref_impl.hpp	(revision 1158)
@@ -263,5 +263,24 @@
   }
                      
-
+  template <typename T> 
+  bool operator== (const CEnum_ref<T>& lhs, const typename T::t_enum& rhs)
+  {
+     if (lhs.isEmpty()) return false;
+     return (lhs.get() == rhs);
+  }
+
+  template <typename T> 
+  bool operator== (const typename T::t_enum& lhs, const CEnum_ref<T>& rhs)
+  {
+    return rhs == lhs;
+  }
+
+  template <typename T> 
+  bool operator== (const CEnum_ref<T>& lhs, const CEnum_ref<T>& rhs)
+  {
+    if ((lhs.isEmpty() && !rhs.isEmpty()) || (!lhs.isEmpty() && rhs.isEmpty())) return false;
+    if (lhs.isEmpty() && rhs.isEmpty()) return true;
+    return (lhs.get() == rhs.get());
+  }
   
   template <typename T>
Index: /XIOS/dev/dev_olga/src/type/message.cpp
===================================================================
--- /XIOS/dev/dev_olga/src/type/message.cpp	(revision 1157)
+++ /XIOS/dev/dev_olga/src/type/message.cpp	(revision 1158)
@@ -27,6 +27,5 @@
      size_t retSize=0 ;
      
-     for(it=typeList.begin();it!=typeList.end();it++)
-    	 retSize+=(*it)->size() ;
+     for(it=typeList.begin();it!=typeList.end();it++) retSize+=(*it)->size() ;
      return retSize ;
    }
Index: /XIOS/dev/dev_olga/src/type/type.hpp
===================================================================
--- /XIOS/dev/dev_olga/src/type/type.hpp	(revision 1157)
+++ /XIOS/dev/dev_olga/src/type/type.hpp	(revision 1158)
@@ -94,5 +94,5 @@
     const CType_ref& operator = (CType<T>& val) const ;
     const CType_ref& operator = (const CType_ref& val) const;
-    operator T&() const;
+    operator T&() const;    
 
     inline virtual CBaseType* clone(void) const   { return _clone(); }
@@ -127,4 +127,25 @@
     size_t _size(void) const ;
   } ;
+
+  template <typename T> bool operator==(const CType<T>& lhs, const T& rhs);   
+  template <typename T> bool operator==(const T& lhs, const CType<T>& rhs);   
+  template <typename T> bool operator==(const CType_ref<T>& lhs, const T& rhs);   
+  template <typename T> bool operator==(const T& lhs, const CType_ref<T>& rhs); 
+  template <typename T> bool operator==(const CType<T>& lhs, const CType<T>& rhs); 
+  template <typename T> bool operator==(const CType_ref<T>& lhs, const CType_ref<T>& rhs); 
+
+  template <typename T>
+  bool operator==(const CType_ref<T>& lhs, const CType<T>& rhs)
+  {
+    if ((lhs.isEmpty() && !rhs.isEmpty()) || (!lhs.isEmpty() && rhs.isEmpty())) return false;
+    if (lhs.isEmpty() && rhs.isEmpty()) return true;
+    return (*lhs.ptrValue == *rhs.ptrValue);
+  } 
+
+  template <typename T>
+  bool operator==(const CType<T>& lhs, const CType_ref<T>& rhs)
+  {
+    return (rhs == lhs);
+  }
 
 
Index: /XIOS/dev/dev_olga/src/type/type_decl.cpp
===================================================================
--- /XIOS/dev/dev_olga/src/type/type_decl.cpp	(revision 1157)
+++ /XIOS/dev/dev_olga/src/type/type_decl.cpp	(revision 1158)
@@ -12,15 +12,23 @@
   template class CType<decl_type> ; \
   template class CType_ref<decl_type> ; \
-  template CBufferOut& operator<< <decl_type> (CBufferOut& buffer, const CType<decl_type>& type) ; \
-  template CBufferOut& operator<< <decl_type> (CBufferOut& buffer, const CType_ref<decl_type>& type) ; \
-  template CBufferOut& operator<< <decl_type> (CBufferOut& buffer, decl_type& type) ; \
-  template CBufferOut& operator<< <decl_type> (CBufferOut& buffer, const decl_type& type) ; \
-  template CBufferIn& operator>> <decl_type> (CBufferIn& buffer, CType<decl_type>& type) ; \
-  template CBufferIn& operator>> <decl_type> (CBufferIn& buffer, const CType_ref<decl_type>& type) ; \
-  template CBufferIn& operator>> <decl_type> (CBufferIn& buffer, decl_type& type) ; \
-/*  template CMessage& operator<< <decl_type> (CMessage& msg, const CType<decl_type>& type) ;*/ \
-/*  template CMessage& operator<< <decl_type> (CMessage& msg, const CType_ref<decl_type>& type) ;*/ \
-  template CMessage& operator<< <decl_type> (CMessage& msg, const decl_type& type) ; \
-  template CMessage& operator<< <decl_type> (CMessage& msg, decl_type& type) ;
+  template CBufferOut& operator<< <decl_type> (CBufferOut& buffer, const CType<decl_type>& type) ;       \
+  template CBufferOut& operator<< <decl_type> (CBufferOut& buffer, const CType_ref<decl_type>& type) ;   \
+  template CBufferOut& operator<< <decl_type> (CBufferOut& buffer, decl_type& type) ;                    \
+  template CBufferOut& operator<< <decl_type> (CBufferOut& buffer, const decl_type& type) ;              \
+  template CBufferIn& operator>> <decl_type> (CBufferIn& buffer, CType<decl_type>& type) ;               \
+  template CBufferIn& operator>> <decl_type> (CBufferIn& buffer, const CType_ref<decl_type>& type) ;     \
+  template CBufferIn& operator>> <decl_type> (CBufferIn& buffer, decl_type& type) ;                      \
+/*  template CMessage& operator<< <decl_type> (CMessage& msg, const CType<decl_type>& type) ;*/          \
+/*  template CMessage& operator<< <decl_type> (CMessage& msg, const CType_ref<decl_type>& type) ;*/      \
+  template CMessage& operator<< <decl_type> (CMessage& msg, const decl_type& type) ;                     \
+  template CMessage& operator<< <decl_type> (CMessage& msg, decl_type& type) ;                           \
+  template bool operator==(const CType<decl_type>& lhs, const decl_type& rhs);                           \
+  template bool operator==(const decl_type& lhs, const CType<decl_type>& rhs);                           \
+  template bool operator==(const CType_ref<decl_type>& lhs, const decl_type& rhs);                       \
+  template bool operator==(const decl_type& lhs, const CType_ref<decl_type>& rhs);                       \
+  template bool operator==(const CType_ref<decl_type>& lhs, const CType<decl_type>& rhs);                \
+  template bool operator==(const CType<decl_type>& lhs, const CType_ref<decl_type>& rhs);                \
+  template bool operator==(const CType<decl_type>& lhs, const CType<decl_type>& rhs);                    \
+  template bool operator==(const CType_ref<decl_type>& lhs, const CType_ref<decl_type>& rhs);    
   
   macro(string)
Index: /XIOS/dev/dev_olga/src/type/type_impl.hpp
===================================================================
--- /XIOS/dev/dev_olga/src/type/type_impl.hpp	(revision 1157)
+++ /XIOS/dev/dev_olga/src/type/type_impl.hpp	(revision 1158)
@@ -211,4 +211,25 @@
   }
 
+  template <typename T>
+  bool operator==(const CType<T>& lhs, const T& rhs)
+  {
+    if (lhs.isEmpty()) return false;
+    return (*lhs.ptrValue == rhs);    
+  }
+
+  template <typename T>
+  bool operator==(const T& lhs, const CType<T>& rhs)
+  {
+    return (rhs == lhs);
+  }
+
+  template <typename T>
+  bool operator==(const CType<T>& lhs, const CType<T>& rhs)
+  {
+    if ((lhs.isEmpty() && !rhs.isEmpty()) || (!lhs.isEmpty() && rhs.isEmpty())) return false;
+    if (lhs.isEmpty() && rhs.isEmpty()) return true;
+    
+    return (*lhs.ptrValue == *rhs.ptrValue);
+  }
 
   template <typename T>
Index: /XIOS/dev/dev_olga/src/type/type_ref_impl.hpp
===================================================================
--- /XIOS/dev/dev_olga/src/type/type_ref_impl.hpp	(revision 1157)
+++ /XIOS/dev/dev_olga/src/type/type_ref_impl.hpp	(revision 1158)
@@ -201,5 +201,25 @@
   }
                      
-
+  template <typename T>
+  bool operator==(const CType_ref<T>& lhs, const T& rhs)
+  {
+    if (lhs.isEmpty()) return false;
+    return (*lhs.ptrValue == rhs);    
+  }
+
+  template <typename T>
+  bool operator==(const T& lhs, const CType_ref<T>& rhs)
+  {
+    return (rhs == lhs);
+  }
+
+  template <typename T>
+  bool operator==(const CType_ref<T>& lhs, const CType_ref<T>& rhs)
+  {
+    if ((lhs.isEmpty() && !rhs.isEmpty()) || (!lhs.isEmpty() && rhs.isEmpty())) return false;
+    if (lhs.isEmpty() && rhs.isEmpty()) return true;
+    
+    return (*lhs.ptrValue == *rhs.ptrValue);
+  }
   
   template <typename T>
Index: /XIOS/dev/dev_olga/src/utils.hpp
===================================================================
--- /XIOS/dev/dev_olga/src/utils.hpp	(revision 1157)
+++ /XIOS/dev/dev_olga/src/utils.hpp	(revision 1158)
@@ -257,4 +257,7 @@
     return 1e-12;
   }
+  static inline bool isnan(const Scalar& v) {
+    return (v != v);
+  }
 };
 
Index: /XIOS/dev/dev_olga/src/xios_spl.hpp
===================================================================
--- /XIOS/dev/dev_olga/src/xios_spl.hpp	(revision 1157)
+++ /XIOS/dev/dev_olga/src/xios_spl.hpp	(revision 1158)
@@ -52,4 +52,6 @@
 typedef  unsigned long int    ulong;
 
+const size_t stringArrayLen=255 ;
+
 /// XIOS headers ///
 #include "configure.hpp"
Index: /XIOS/dev/dev_olga/src/xml_parser.cpp
===================================================================
--- /XIOS/dev/dev_olga/src/xml_parser.cpp	(revision 1157)
+++ /XIOS/dev/dev_olga/src/xml_parser.cpp	(revision 1158)
@@ -70,16 +70,8 @@
                   CContext::setCurrent(attributes["id"]) ;
 
-                  bool hasctxt = CContext::has(attributes["id"]);
-
-                  if(hasctxt)
-                  {
-                     DEBUG("The context will not be processed because it exist an other context with the same id" );
-                     continue;
-                  }
 
                   if (isParseAll)
                   {
                     CContext* context = CContext::create(attributes["id"]);
-//                  if (!hasctxt)  group_context->addChild(context);
                     context->parse(node);
 
@@ -92,5 +84,4 @@
                     {
                       CContext* context = CContext::create(*it);
-  //                  if (!hasctxt)  group_context->addChild(context);
                       context->parse(node);
 
